"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var common_1 = require("@theia/core/lib/common");
var browser_1 = require("@theia/core/lib/browser");
var core_1 = require("@theia/core");
var file_resource_1 = require("@theia/filesystem/lib/browser/file-resource");
var browser_2 = require("@theia/workspace/lib/browser");
var filesystem_watcher_1 = require("@theia/filesystem/lib/browser/filesystem-watcher");
var common_2 = require("@theia/filesystem/lib/common");
var uri_1 = require("@theia/core/lib/common/uri");
var terminal_service_1 = require("@theia/terminal/lib/browser/base/terminal-service");
var frontend_application_state_1 = require("@theia/core/lib/browser/frontend-application-state");
var mini_browser_open_handler_1 = require("@theia/mini-browser/lib/browser/mini-browser-open-handler");
var outline_view_contribution_1 = require("@theia/outline-view/lib/browser/outline-view-contribution");
var application_shell_1 = require("@theia/core/lib/browser/shell/application-shell");
var editor_command_1 = require("@theia/editor/lib/browser/editor-command");
var quick_file_open_1 = require("@theia/file-search/lib/browser/quick-file-open");
exports.Programmr_matplotmenuCommand = {
    id: 'Programmr_matplotmenu.command',
    label: "Shows a message"
};
exports.RunExtensionCommand = {
    id: 'RunExtension.command',
    label: "View Graph"
};
exports.CompileExtensionCommand = {
    id: 'CompileExtension.command',
    label: "Run"
};
exports.configObj2 = {};
var RunMenus;
(function (RunMenus) {
    RunMenus.RUN = __spread(core_1.MAIN_MENU_BAR, ['1_run']);
    RunMenus.RUN_NEW = __spread(RunMenus.RUN, ['3_run']);
    RunMenus.BUILD_NEW = __spread(RunMenus.RUN, ['1_run']);
    RunMenus.RUN_TASKS = __spread(RunMenus.RUN, ['2_run']);
    RunMenus.OPEN_NEW = __spread(RunMenus.RUN, ['4_run']);
})(RunMenus = exports.RunMenus || (exports.RunMenus = {}));
var Programmr_matplotmenuCommandContribution = /** @class */ (function () {
    function Programmr_matplotmenuCommandContribution(messageService, terminalService, fileSystem, watcher, miniBrowser, shell, outlineViewContribution, menuRegistry) {
        this.messageService = messageService;
        this.terminalService = terminalService;
        this.fileSystem = fileSystem;
        this.watcher = watcher;
        this.miniBrowser = miniBrowser;
        this.shell = shell;
        this.outlineViewContribution = outlineViewContribution;
        this.menuRegistry = menuRegistry;
        this.configObj = '';
    }
    Programmr_matplotmenuCommandContribution.prototype.setConfigObject = function (obj) {
        this.configObj = obj;
    };
    Programmr_matplotmenuCommandContribution.prototype.getConfigObject = function () {
        return this.configObj;
    };
    Programmr_matplotmenuCommandContribution.prototype.onStart = function (app) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.shell.expandPanel('left');
                this.stateService.reachedState('ready').then(function (a) {
                    console.log("strt:2");
                    //set autosave on
                    //this.shell.expandPanel('left');
                    // this.shell.expandPanel('right');
                    // this.outlineViewContribution.openView(); 
                    _this.preferencesService.set(editor_command_1.EditorCommandContribution.AUTOSAVE_PREFERENCE, 'on');
                    var current = _this.workspaceService.workspace;
                    //get the current workspace project path and open the default file
                    try {
                        //console.log("menu"+document.querySelectorAll(".p-MenuBar-item"));
                        var node = document.querySelectorAll(".p-MenuBar-item");
                        var el = node[node.length - 1];
                        el.style.display = "none";
                    }
                    catch (e) {
                        console.log(e);
                    }
                    // try{
                    //this.quickFileOpenService.openFile(new URI(current.uri+"/src/app/app.component.ts"));
                    // }catch(e){
                    //  console.log("open err"+e); 
                    //}
                    _this.openDefaultFile(current.uri);
                });
                return [2 /*return*/];
            });
        });
    };
    Programmr_matplotmenuCommandContribution.prototype.openDefaultFile = function (path) {
        return __awaiter(this, void 0, void 0, function () {
            var uri, resource, current, projectPath, contents, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        uri = new uri_1.default(path + "/.pmainfile");
                        resource = new file_resource_1.FileResource(uri, this.fileSystem, this.watcher);
                        current = this.workspaceService.workspace;
                        projectPath = current.uri.toString().replace('file://', '');
                        return [4 /*yield*/, resource.readContents()];
                    case 1:
                        contents = _a.sent();
                        contents = contents.replace(/\n/g, '');
                        contents = contents.replace(/\r/g, '');
                        this.configObj = JSON.parse(contents);
                        exports.configObj2 = JSON.parse(contents);
                        ;
                        this.setConfigObject(this.configObj);
                        if ("mainfile" in this.configObj) {
                            this.quickFileOpenService.openFile(new uri_1.default(path + "/" + this.configObj.mainfile));
                        }
                        if ("previewApp" in this.configObj) {
                            console.log("preview:true");
                            //preivew already deployed android app in appetize
                            if ("runmenucommand" in this.configObj) {
                                this.runTerminalCommand(this.configObj.runmenucommand + " " + projectPath);
                            }
                            this.monitorOutputUrl();
                        }
                        if ("outputtype" in this.configObj && this.configObj.outputtype == "graph") {
                            this.menuRegistry.registerMenuAction(RunMenus.RUN_NEW, {
                                commandId: exports.RunExtensionCommand.id,
                                label: 'View Graph',
                                order: '1'
                            });
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        //console.log(e);
                        console.log("exceptio .. no config open default index.js file");
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Programmr_matplotmenuCommandContribution.prototype.getConfiguredCommandFor = function (command) {
        return __awaiter(this, void 0, void 0, function () {
            var current, projectPath, uri, resource, contents, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        console.log("configObj2=" + exports.configObj2);
                        current = this.workspaceService.workspace;
                        projectPath = current.uri.toString().replace('file://', '');
                        uri = new uri_1.default(current.uri + "/.pmainfile");
                        resource = new file_resource_1.FileResource(uri, this.fileSystem, this.watcher);
                        return [4 /*yield*/, resource.readContents()];
                    case 1:
                        contents = _a.sent();
                        contents = contents.replace(/\n/g, '');
                        contents = contents.replace(/\r/g, '');
                        this.configObj = JSON.parse(contents);
                        if (command == 'run') {
                            if ("runmenucommand" in this.configObj) {
                                this.runTerminalCommand(this.configObj.runmenucommand + " " + projectPath);
                                if ("outputtype" in this.configObj && this.configObj.outputtype == "graph")
                                    this.monitorOutputUrl();
                            }
                        }
                        else if (command == 'compile') {
                            if ("compilemenucommand" in this.configObj) {
                                this.runTerminalCommand(this.configObj.compilemenucommand);
                            }
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        e_2 = _a.sent();
                        console.log(e_2);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Programmr_matplotmenuCommandContribution.prototype.getOutputUrl = function (command) {
        return __awaiter(this, void 0, void 0, function () {
            var current, uri, resource, contents, windowUrl, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        console.log("configObj2=" + exports.configObj2);
                        current = this.workspaceService.workspace;
                        uri = new uri_1.default(current.uri + "/.outputurl");
                        resource = new file_resource_1.FileResource(uri, this.fileSystem, this.watcher);
                        return [4 /*yield*/, resource.readContents()];
                    case 1:
                        contents = _a.sent();
                        contents = contents.replace(/\n/g, '');
                        contents = contents.replace(/\r/g, '');
                        //let outputObj = JSON.parse(contents);
                        if (contents.length > 1) {
                            clearInterval(this.interval);
                            console.log("publicKey found" + window.location.href);
                            windowUrl = window.location.href;
                            windowUrl = windowUrl.replace("/#/", "/mini-browser/");
                            if ("graphfile" in this.configObj) {
                                windowUrl += "/" + this.configObj.graphfile;
                            }
                            else
                                windowUrl += "/plot.png";
                            this.openUrlInPreview(windowUrl);
                        }
                        else {
                            console.log("entry not found");
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        e_3 = _a.sent();
                        console.log(e_3);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Programmr_matplotmenuCommandContribution.prototype.registerCommands = function (registry) {
        var _this = this;
        registry.registerCommand(exports.Programmr_matplotmenuCommand, {
            execute: function () { return _this.messageService.info('Hello World!'); }
        });
        registry.registerCommand(exports.CompileExtensionCommand, {
            execute: function () {
                //this.messageService.info('Running...');
                _this.getConfiguredCommandFor('run');
                //this.openUrlInPreview('https://appetize.io/embed/gzghhwdtg34e8mbv5w4vfyfu7w?device=nexus5&scale=75&orientation=portrait&osVersion=8.1');
            }
        });
        registry.registerCommand(exports.RunExtensionCommand, {
            execute: function () {
                //this.messageService.info('Loading...');
                //this.getConfiguredCommandFor('run');
                //this.openUrlInPreview('https://appetize.io/embed/gzghhwdtg34e8mbv5w4vfyfu7w?device=nexus5&scale=75&orientation=portrait&osVersion=8.1');
                //this.monitorOutputUrl();
                var windowUrl = window.location.href;
                windowUrl = windowUrl.replace("/#/", "/mini-browser/");
                if ("graphfile" in _this.configObj) {
                    windowUrl += "/" + _this.configObj.graphfile;
                }
                else
                    windowUrl += "/plot.png";
                _this.openUrlInPreview(windowUrl);
            }
        });
    };
    Programmr_matplotmenuCommandContribution.prototype.runTerminalCommand = function (command) {
        return __awaiter(this, void 0, void 0, function () {
            var terminal;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        terminal = this.terminalService.currentTerminal;
                        if (!!terminal) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.terminalService.newTerminal({ created: new Date().toString() })];
                    case 1:
                        terminal = (_a.sent());
                        return [4 /*yield*/, terminal.start()];
                    case 2:
                        _a.sent();
                        this.terminalService.activateTerminal(terminal);
                        _a.label = 3;
                    case 3:
                        terminal.sendText(command + "\n");
                        return [2 /*return*/];
                }
            });
        });
    };
    //dj:
    Programmr_matplotmenuCommandContribution.prototype.monitorOutputUrl = function () {
        var _this = this;
        this.interval = setInterval(function () {
            _this.getOutputUrl('run');
        }, 1000);
    };
    Programmr_matplotmenuCommandContribution.prototype.openUrlInPreview = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var current;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!("viewtype" in exports.configObj2 && exports.configObj2.viewtype == "browser")) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.miniBrowser.openPreview(url)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        if ("viewtype" in exports.configObj2 && exports.configObj2.viewtype == "file") {
                            current = this.workspaceService.workspace;
                            this.shell.collapsePanel('bottom');
                            this.quickFileOpenService.openFile(new uri_1.default(current.uri + "/" + exports.configObj2.graphfile));
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Programmr_matplotmenuCommandContribution.prototype.registerMenus = function (menus) {
        menus.registerSubmenu(RunMenus.RUN, 'Run');
        menus.registerMenuAction(RunMenus.BUILD_NEW, {
            commandId: exports.CompileExtensionCommand.id,
            label: 'Run',
            order: '0'
        });
        menus.registerMenuAction(browser_1.CommonMenus.EDIT_FIND, {
            commandId: exports.RunExtensionCommand.id,
            label: 'View Graph'
        });
        menus.registerMenuAction(browser_1.CommonMenus.EDIT_FIND, {
            commandId: exports.CompileExtensionCommand.id,
            label: 'Run'
        });
    };
    __decorate([
        inversify_1.inject(frontend_application_state_1.FrontendApplicationStateService),
        __metadata("design:type", frontend_application_state_1.FrontendApplicationStateService)
    ], Programmr_matplotmenuCommandContribution.prototype, "stateService", void 0);
    __decorate([
        inversify_1.inject(browser_2.WorkspaceService),
        __metadata("design:type", browser_2.WorkspaceService)
    ], Programmr_matplotmenuCommandContribution.prototype, "workspaceService", void 0);
    __decorate([
        inversify_1.inject(browser_1.PreferenceService),
        __metadata("design:type", Object)
    ], Programmr_matplotmenuCommandContribution.prototype, "preferencesService", void 0);
    __decorate([
        inversify_1.inject(quick_file_open_1.QuickFileOpenService),
        __metadata("design:type", quick_file_open_1.QuickFileOpenService)
    ], Programmr_matplotmenuCommandContribution.prototype, "quickFileOpenService", void 0);
    Programmr_matplotmenuCommandContribution = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(common_1.MessageService)),
        __param(1, inversify_1.inject(terminal_service_1.TerminalService)),
        __param(2, inversify_1.inject(common_2.FileSystem)),
        __param(3, inversify_1.inject(filesystem_watcher_1.FileSystemWatcher)),
        __param(4, inversify_1.inject(mini_browser_open_handler_1.MiniBrowserOpenHandler)),
        __param(5, inversify_1.inject(application_shell_1.ApplicationShell)),
        __param(6, inversify_1.inject(outline_view_contribution_1.OutlineViewContribution)),
        __param(7, inversify_1.inject(common_1.MenuModelRegistry)),
        __metadata("design:paramtypes", [common_1.MessageService, Object, Object, filesystem_watcher_1.FileSystemWatcher,
            mini_browser_open_handler_1.MiniBrowserOpenHandler,
            application_shell_1.ApplicationShell,
            outline_view_contribution_1.OutlineViewContribution,
            common_1.MenuModelRegistry])
    ], Programmr_matplotmenuCommandContribution);
    return Programmr_matplotmenuCommandContribution;
}());
exports.Programmr_matplotmenuCommandContribution = Programmr_matplotmenuCommandContribution;
//# sourceMappingURL=programmr_matplotmenu-contribution.js.map